package com.hai.dao;

import com.hai.entity.HighActivityAwardSerialNum;
import com.hai.entity.HighActivityAwardSerialNumExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityAwardSerialNumMapper extends HighActivityAwardSerialNumMapperExt {
    @SelectProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="countByExample")
    long countByExample(HighActivityAwardSerialNumExample example);

    @DeleteProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityAwardSerialNumExample example);

    @Delete({
        "delete from high_activity_award_serial_num",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_award_serial_num (activity_info_id, activity_award_id, ",
        "serial_num, `status`, ",
        "create_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{activityInfoId,jdbcType=BIGINT}, #{activityAwardId,jdbcType=BIGINT}, ",
        "#{serialNum,jdbcType=VARCHAR}, #{status,jdbcType=INTEGER}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityAwardSerialNum record);

    @InsertProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityAwardSerialNum record);

    @SelectProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="serial_num", property="serialNum", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityAwardSerialNum> selectByExample(HighActivityAwardSerialNumExample example);

    @Select({
        "select",
        "id, activity_info_id, activity_award_id, serial_num, `status`, create_time, ",
        "ext_1, ext_2, ext_3",
        "from high_activity_award_serial_num",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="activity_award_id", property="activityAwardId", jdbcType=JdbcType.BIGINT),
        @Result(column="serial_num", property="serialNum", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityAwardSerialNum selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityAwardSerialNum record, @Param("example") HighActivityAwardSerialNumExample example);

    @UpdateProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityAwardSerialNum record, @Param("example") HighActivityAwardSerialNumExample example);

    @UpdateProvider(type=HighActivityAwardSerialNumSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityAwardSerialNum record);

    @Update({
        "update high_activity_award_serial_num",
        "set activity_info_id = #{activityInfoId,jdbcType=BIGINT},",
          "activity_award_id = #{activityAwardId,jdbcType=BIGINT},",
          "serial_num = #{serialNum,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityAwardSerialNum record);
}